--[[
	SDetector
	By Shimatsukaze
	Distributed under the terms of the MIT License.
	http://opensource.org/licenses/MIT
]]--

require("ShimakazeDet")

SD={
	count=0,
	rate=0,
	sound={},
	beat={},
	part=512,
	bpm=0,
	begin=0
}

function SD:loadData(data,part)
	self.count=data:getSampleCount()
	self.rate=data:getSampleRate()
	self.sound={}
	self.beat={}
	self.part=part or self.part
	self.bmp=0
	self.begin=0
	ShimakazeDet.init(-1)
	if data:getChannels()==1 then
		for i=0,self.count-1 do
			self.sound[i]=data:getSample(i)
		end
	else
		for i=0,self.count-1 do
			self.sound[i]=(data:getSample(i*2)+data:getSample(i*2+1))/2
		end
	end
end

function SD:analyze(L)
	local R=L*self.part-1
	L=(L-1)*self.part
	if L<0 or R>=self.count then
		return -1
	end
	ShimakazeDet.init(1)
	for i=L,R do
		ShimakazeDet.insert(self.sound[i])
	end
	ShimakazeDet.calculate(R/self.rate)
	return R/self.count
end

function SD:getFFT(mid)
	local L,R=mid-self.part/2,mid+self.part/2-1
	if L<0 or R>=self.count then
		return
	end
	ShimakazeDet.init(1)
	for i=L,R do
		ShimakazeDet.insert(self.sound[i])
	end
	return ShimakazeDet.FFT()
end

function SD:getSample(t)
	return self.sound[t]
end

function SD:finish()
	self.beat={ShimakazeDet.beats()}
	self.bpm,self.begin=ShimakazeDet.BPM()
end